local Test = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0")

local Mode7=AceLibrary("Mode7-1.0")
local GPS=AceLibrary("GPS-1.0")

local Mode7Scaling=1

Test.consoleOptions = {

	name = "Show",
	desc = "Shows the main window",
	type = 'execute',
	func = function() Test.Frame:Show() end
}

Test:RegisterChatCommand({"/dc","/dungeoncrawler"}, Test.consoleOptions)

local minimapPlayerModel
function Test:OnEnable()
	Test:CreateWindow()

	Test:ScheduleRepeatingEvent(Test.OnTick,0.04)


	-- Create a table of all the Minimap's children objectSimpleCompass_Saved.
	local children = {Minimap:GetChildren()};
	
	for i=getn(children), 1, -1 do
		-- Iterate over them all, starting from the end of the list to see if the object reference is a model.
		-- If it is, and it has no name (in case some addon attached a model to it), it's probably the right one.
		if children[i]:IsObjectType("Model") and not children[i]:GetName() and not minimapPlayerModel then
			-- Found, setting as the addon's local to keep the reference.
			minimapPlayerModel = children[i];
			return;
		end
	end
end

local mx=-0.811264593
local bx=0.16194637
local my=0.80859651
local by=0.59494442


function Test:OnTick()
	local ang=-math.deg(minimapPlayerModel:GetFacing())
	local x,y=GPS:GetPosition()

	x=0.5-(mx*x+bx)
	y=0.5-(my*y+by)


	Test.Mode7:SetCoords(8,x,y,ang)
end

function Test:CreateWindow()
	Test.Frame=CreateFrame("Frame","Dungeon Crawler",UIParent)

	local theFrame=Test.Frame

	theFrame:ClearAllPoints()
	theFrame:SetPoint("CENTER",UIParent)
	theFrame:SetHeight(200+32)
	theFrame:SetWidth(202)

	theFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\AddOns\\Mode7Test\\textures\\otravi-semi-full-border", edgeSize = 32,
		insets = {left = 1, right = 1, top = 20, bottom = 1},
	})
	theFrame:SetBackdropBorderColor(1.0,0.0,0.0)
	theFrame:SetBackdropColor(24/255, 24/255, 24/255)

	theFrame:EnableMouse(true)
	theFrame:SetMovable(true)

	theFrame:SetScript("OnMouseDown", function() 
						if ( ( ( not this.isLocked ) or ( this.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
						  this:StartMoving();
						  this.isMoving = true;
						 end
						end)
	theFrame:SetScript("OnMouseUp", function() 
						if ( this.isMoving ) then
						  this:StopMovingOrSizing();
						  this.isMoving = false;
						 end
						end)
					
	theFrame:SetScript("OnHide", function()
						if ( this.isMoving ) then
						  this:StopMovingOrSizing();
						  this.isMoving = false;
						 end
						end)

	theFrame.Title=theFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	theFrame.Title:SetPoint("TOPLEFT",theFrame,"TOPLEFT",6,-15)
	theFrame.Title:SetTextColor(1.0,1.0,1.0)
	theFrame.Title:SetText("Dungeon Crawler")


	Test.Mode7=Mode7:CreateTexture(theFrame,nil,"ARTWORK","CENTER","CENTER",0,-15,200,200,DCScalingFunction)
	Test.Mode7:SetTexture("Interface\\AddOns\\DungeonCrawler\\textures\\AuchAuchenaiCrypts")
	Test.Mode7:SetCoords(8,0,0,0)
	Test.Mode7:SetColor(1,1,1,0.75)
	
	theFrame.CloseButton=CreateFrame("Button",nil,theFrame)
	theFrame.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
	theFrame.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
	theFrame.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	theFrame.CloseButton:SetWidth(20)
	theFrame.CloseButton:SetHeight(20)
	theFrame.CloseButton:SetPoint("TOPRIGHT",theFrame,"TOPRIGHT",-4,-12)
	theFrame.CloseButton:SetScript("OnClick",function() this:GetParent():Hide() end)
end


function DCScalingFunction(i)
	return Mode7Scaling*i
end